diff --git a/xlators/mgmt/glusterd/src/glusterd-ganesha.c b/xlators/mgmt/glusterd/src/glusterd-ganesha.c
index cf567fa4172..c359cdbb1c6 100644
--- a/xlators/mgmt/glusterd/src/glusterd-ganesha.c
+++ b/xlators/mgmt/glusterd/src/glusterd-ganesha.c
@@ -405,7 +405,7 @@ check_host_list(void)
     /* Hostlist is a comma separated list now */
     hostname = strtok(hostlist, ",");
     while (hostname != NULL) {
-        ret = gf_is_local_addr(hostname);
+        ret = glusterd_gf_is_local_addr(hostname);
         if (ret) {
             gf_msg(this->name, GF_LOG_INFO, 0, GD_MSG_NFS_GNS_HOST_FOUND,
                    "ganesha host found "
diff --git a/xlators/mgmt/glusterd/src/glusterd-handler.c b/xlators/mgmt/glusterd/src/glusterd-handler.c
index 6e6593e7263..521c405c165 100644
--- a/xlators/mgmt/glusterd/src/glusterd-handler.c
+++ b/xlators/mgmt/glusterd/src/glusterd-handler.c
@@ -1090,7 +1090,7 @@ __glusterd_handle_cli_probe(rpcsvc_request_t *req)
                      "only checking probe address vs. bind address");
         ret = gf_is_same_address(bind_name, hostname);
     } else {
-        ret = gf_is_local_addr(hostname);
+        ret = glusterd_gf_is_local_addr(hostname);
     }
     if (ret) {
         glusterd_xfer_cli_probe_resp(req, 0, GF_PROBE_LOCALHOST, NULL, hostname,
@@ -2109,7 +2109,7 @@ __glusterd_handle_sync_volume(rpcsvc_request_t *req)
            "for volume %s",
            (flags & GF_CLI_SYNC_ALL) ? "all" : volname);
 
-    if (gf_is_local_addr(hostname)) {
+    if (glusterd_gf_is_local_addr(hostname)) {
         ret = -1;
         snprintf(msg, sizeof(msg),
                  "sync from localhost"
diff --git a/xlators/mgmt/glusterd/src/glusterd-handshake.c b/xlators/mgmt/glusterd/src/glusterd-handshake.c
index 7cb70fcb4e2..2b4ad5f7f7b 100644
--- a/xlators/mgmt/glusterd/src/glusterd-handshake.c
+++ b/xlators/mgmt/glusterd/src/glusterd-handshake.c
@@ -1000,7 +1000,7 @@ __server_getspec(rpcsvc_request_t *req)
      * meant for external users.
      * For unix domain socket, address will be empty.
      */
-    if (strlen(addrstr) == 0 || gf_is_local_addr(addrstr)) {
+    if (strlen(addrstr) == 0 || glusterd_gf_is_local_addr(addrstr)) {
         ret = build_volfile_path(volume, filename, sizeof(filename),
                                  TRUSTED_PREFIX, dict);
     } else {
diff --git a/xlators/mgmt/glusterd/src/glusterd-mem-types.h b/xlators/mgmt/glusterd/src/glusterd-mem-types.h
index 17052cee263..fc6deb7ad7c 100644
--- a/xlators/mgmt/glusterd/src/glusterd-mem-types.h
+++ b/xlators/mgmt/glusterd/src/glusterd-mem-types.h
@@ -52,6 +52,7 @@ typedef enum gf_gld_mem_types_ {
     gf_gld_mt_snap_create_args_t,
     gf_gld_mt_glusterd_brick_proc_t,
     gf_gld_mt_glusterd_svc_proc_t,
+    gf_gld_mt_hostname_t,
     gf_gld_mt_end,
 } gf_gld_mem_types_t;
 #endif
diff --git a/xlators/mgmt/glusterd/src/glusterd-messages.h b/xlators/mgmt/glusterd/src/glusterd-messages.h
index 435a43df85d..5bdbb3d0717 100644
--- a/xlators/mgmt/glusterd/src/glusterd-messages.h
+++ b/xlators/mgmt/glusterd/src/glusterd-messages.h
@@ -302,6 +302,7 @@ GLFS_MSGID(
     GD_MSG_SHD_OBJ_GET_FAIL, GD_MSG_SVC_ATTACH_FAIL, GD_MSG_ATTACH_INFO,
     GD_MSG_DETACH_INFO, GD_MSG_SVC_DETACH_FAIL,
     GD_MSG_RPC_TRANSPORT_GET_PEERNAME_FAIL, GD_MSG_CLUSTER_RC_ENABLE,
-    GD_MSG_NFS_GANESHA_DISABLED, GD_MSG_GANESHA_NOT_RUNNING, GD_MSG_SNAP_WARN);
+    GD_MSG_NFS_GANESHA_DISABLED, GD_MSG_NO_MEMORY_STR,
+    GD_MSG_GANESHA_NOT_RUNNING, GD_MSG_SNAP_WARN);
 
 #endif /* !_GLUSTERD_MESSAGES_H_ */
diff --git a/xlators/mgmt/glusterd/src/glusterd-op-sm.c b/xlators/mgmt/glusterd/src/glusterd-op-sm.c
index b3d194c6b2e..db59262e38a 100644
--- a/xlators/mgmt/glusterd/src/glusterd-op-sm.c
+++ b/xlators/mgmt/glusterd/src/glusterd-op-sm.c
@@ -1613,7 +1613,7 @@ glusterd_op_stage_sync_volume(dict_t *dict, char **op_errstr)
         goto out;
     }
 
-    if (gf_is_local_addr(hostname)) {
+    if (glusterd_gf_is_local_addr(hostname)) {
         // volname is not present in case of sync all
         ret = dict_get_strn(dict, "volname", SLEN("volname"), &volname);
         if (!ret) {
@@ -3006,7 +3006,7 @@ glusterd_op_sync_volume(dict_t *dict, char **op_errstr, dict_t *rsp_dict)
         goto out;
     }
 
-    if (!gf_is_local_addr(hostname)) {
+    if (!glusterd_gf_is_local_addr(hostname)) {
         ret = 0;
         goto out;
     }
diff --git a/xlators/mgmt/glusterd/src/glusterd-peer-utils.c b/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
index 82acf5bf03c..b730737c890 100644
--- a/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-peer-utils.c
@@ -254,7 +254,7 @@ glusterd_hostname_to_uuid(char *hostname, uuid_t uuid)
         ret = 0;
         gf_uuid_copy(uuid, peerinfo->uuid);
     } else {
-        if (gf_is_local_addr(hostname)) {
+        if (glusterd_gf_is_local_addr(hostname)) {
             gf_uuid_copy(uuid, MY_UUID);
             ret = 0;
         } else {
diff --git a/xlators/mgmt/glusterd/src/glusterd-replace-brick.c b/xlators/mgmt/glusterd/src/glusterd-replace-brick.c
index 3d13ef95ffd..9d87e599868 100644
--- a/xlators/mgmt/glusterd/src/glusterd-replace-brick.c
+++ b/xlators/mgmt/glusterd/src/glusterd-replace-brick.c
@@ -270,7 +270,7 @@ glusterd_op_stage_replace_brick(dict_t *dict, char **op_errstr,
         goto out;
     }
 
-    if (gf_is_local_addr(host)) {
+    if (glusterd_gf_is_local_addr(host)) {
         ret = glusterd_validate_and_create_brickpath(
             dst_brickinfo, volinfo->volume_id, volinfo->volname, op_errstr,
             is_force, _gf_false);
@@ -278,7 +278,7 @@ glusterd_op_stage_replace_brick(dict_t *dict, char **op_errstr,
             goto out;
     }
 
-    if (!gf_is_local_addr(host)) {
+    if (!glusterd_gf_is_local_addr(host)) {
         RCU_READ_LOCK;
 
         peerinfo = glusterd_peerinfo_find(NULL, host);
diff --git a/xlators/mgmt/glusterd/src/glusterd-reset-brick.c b/xlators/mgmt/glusterd/src/glusterd-reset-brick.c
index e4d247a1d6c..af008d95100 100644
--- a/xlators/mgmt/glusterd/src/glusterd-reset-brick.c
+++ b/xlators/mgmt/glusterd/src/glusterd-reset-brick.c
@@ -145,7 +145,7 @@ glusterd_reset_brick_prevalidate(dict_t *dict, char **op_errstr,
     ret = dict_get_int32n(dict, "ignore-partition", SLEN("ignore-partition"),
                           &ignore_partition);
     ret = 0;
-    if (gf_is_local_addr(host)) {
+    if (glusterd_gf_is_local_addr(host)) {
         ret = glusterd_validate_and_create_brickpath(
             dst_brickinfo, volinfo->volume_id, volinfo->volname, op_errstr,
             is_force, ignore_partition);
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.c b/xlators/mgmt/glusterd/src/glusterd-utils.c
index deec3681e2c..26f93654133 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.c
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.c
@@ -134,6 +134,79 @@ is_brick_mx_enabled(void)
     return ret ? _gf_false : enabled;
 }
 
+static gf_boolean_t
+gd_has_local_address(glusterd_conf_t *priv, const char *hostname)
+{
+    glusterd_hostname_t *hostname_obj = NULL;
+
+    list_for_each_entry(hostname_obj, &priv->hostnames, hostname_list)
+    {
+        if (strcmp(hostname_obj->hostname, hostname) == 0) {
+            return _gf_true;
+        }
+    }
+
+    return _gf_false;
+}
+
+static int
+glusterd_hostname_new(xlator_t *this, const char *hostname,
+                      glusterd_hostname_t **name)
+{
+    glusterd_hostname_t *hostname_obj = NULL;
+    int32_t ret = -1;
+
+    GF_ASSERT(hostname);
+    GF_ASSERT(name);
+
+    hostname_obj = GF_MALLOC(sizeof(*hostname_obj), gf_gld_mt_hostname_t);
+
+    if (!hostname_obj) {
+        gf_msg(this->name, GF_LOG_ERROR, errno, GD_MSG_NO_MEMORY,
+               "Memory allocation is failed");
+        goto out;
+    }
+
+    hostname_obj->hostname = gf_strdup(hostname);
+    CDS_INIT_LIST_HEAD(&hostname_obj->hostname_list);
+
+    *name = hostname_obj;
+    ret = 0;
+
+out:
+    gf_msg_debug("glusterd", 0, "Returning %d", ret);
+    return ret;
+}
+
+gf_boolean_t
+glusterd_gf_is_local_addr(char *hostname)
+{
+    xlator_t *this = NULL;
+    glusterd_conf_t *priv = NULL;
+    glusterd_hostname_t *hostname_obj = NULL;
+    gf_boolean_t found = _gf_false;
+    int ret = 1;
+
+    this = THIS;
+    priv = this->private;
+
+    if (gd_has_local_address(priv, hostname)) {
+        found = _gf_true;
+        goto out;
+    }
+
+    if (gf_is_local_addr(hostname)) {
+        ret = glusterd_hostname_new(this, hostname, &hostname_obj);
+        if (ret)
+            goto out;
+        found = _gf_true;
+        list_add_tail(&hostname_obj->hostname_list, &priv->hostnames);
+    }
+
+out:
+    return found;
+}
+
 int
 get_mux_limit_per_process(int *mux_limit)
 {
@@ -13915,7 +13988,7 @@ rb_update_dstbrick_port(glusterd_brickinfo_t *dst_brickinfo, dict_t *rsp_dict,
     if (!dict_ret)
         dst_brickinfo->port = dst_port;
 
-    if (gf_is_local_addr(dst_brickinfo->hostname)) {
+    if (glusterd_gf_is_local_addr(dst_brickinfo->hostname)) {
         gf_msg("glusterd", GF_LOG_INFO, 0, GD_MSG_BRK_PORT_NO_ADD_INDO,
                "adding dst-brick port no %d", dst_port);
 
@@ -14057,7 +14130,7 @@ glusterd_brick_op_prerequisites(dict_t *dict, char **op, glusterd_op_t *gd_op,
         goto out;
     }
 
-    if (gf_is_local_addr((*src_brickinfo)->hostname)) {
+    if (glusterd_gf_is_local_addr((*src_brickinfo)->hostname)) {
         gf_msg_debug(this->name, 0, "I AM THE SOURCE HOST");
         if ((*src_brickinfo)->port && rsp_dict) {
             ret = dict_set_int32n(rsp_dict, "src-brick-port",
diff --git a/xlators/mgmt/glusterd/src/glusterd-utils.h b/xlators/mgmt/glusterd/src/glusterd-utils.h
index b58f158fd14..90804c8d217 100644
--- a/xlators/mgmt/glusterd/src/glusterd-utils.h
+++ b/xlators/mgmt/glusterd/src/glusterd-utils.h
@@ -86,6 +86,11 @@ typedef struct glusterd_dict_ctx_ {
     char *prefix;
 } glusterd_dict_ctx_t;
 
+typedef struct glusterd_hostname_ {
+    char *hostname;
+    struct list_head hostname_list;
+} glusterd_hostname_t;
+
 gf_boolean_t
 is_brick_mx_enabled(void);
 
@@ -857,4 +862,6 @@ search_brick_path_from_proc(pid_t brick_pid, char *brickpath);
 int32_t
 glusterd_add_shd_to_dict(glusterd_volinfo_t *volinfo, dict_t *dict,
                          int32_t count);
+gf_boolean_t
+glusterd_gf_is_local_addr(char *hostname);
 #endif
diff --git a/xlators/mgmt/glusterd/src/glusterd.c b/xlators/mgmt/glusterd/src/glusterd.c
index 39aea886051..27d470df697 100644
--- a/xlators/mgmt/glusterd/src/glusterd.c
+++ b/xlators/mgmt/glusterd/src/glusterd.c
@@ -1369,6 +1369,19 @@ is_downgrade(dict_t *options, gf_boolean_t *downgrade)
     return ret;
 }
 
+void
+glusterd_destroy_hostname_list(glusterd_conf_t *priv)
+{
+    glusterd_hostname_t *hostname_obj = NULL;
+
+    list_for_each_entry(hostname_obj, &priv->hostnames, hostname_list)
+    {
+        list_del_init(&hostname_obj->hostname_list);
+        GF_FREE(hostname_obj->hostname);
+        GF_FREE(hostname_obj);
+    }
+}
+
 /*
  * init - called during glusterd initialization
  *
@@ -1840,6 +1853,7 @@ init(xlator_t *this)
     CDS_INIT_LIST_HEAD(&conf->missed_snaps_list);
     CDS_INIT_LIST_HEAD(&conf->brick_procs);
     CDS_INIT_LIST_HEAD(&conf->shd_procs);
+    CDS_INIT_LIST_HEAD(&conf->hostnames);
     pthread_mutex_init(&conf->attach_lock, NULL);
     pthread_mutex_init(&conf->volume_lock, NULL);
 
@@ -2083,6 +2097,7 @@ fini(xlator_t *this)
 
     glusterd_stop_uds_listener(this); /*stop unix socket rpc*/
     glusterd_stop_listener(this);     /*stop tcp/ip socket rpc*/
+    glusterd_destroy_hostname_list(this->private); /*Destroy hostname list */
 
 #if 0
        /* Running threads might be using these resourses, we have to cancel/stop
diff --git a/xlators/mgmt/glusterd/src/glusterd.h b/xlators/mgmt/glusterd/src/glusterd.h
index f2651ebe43c..a23e1f611f3 100644
--- a/xlators/mgmt/glusterd/src/glusterd.h
+++ b/xlators/mgmt/glusterd/src/glusterd.h
@@ -236,6 +236,7 @@ typedef struct {
     char workdir[VALID_GLUSTERD_PATHMAX];
     char rundir[VALID_GLUSTERD_PATHMAX];
     char logdir[VALID_GLUSTERD_PATHMAX];
+    struct list_head hostnames;
 } glusterd_conf_t;
 
 typedef struct glusterd_add_dict_args {
